/* eslint-disable */
/*蓝牙使用,简化接口调用*/
/*常量定义*/	
const Blu_init=-1;//初始状态	
const Blu_UnAvailable=0; //蓝牙不可用
const Blu_findingDev=1;//正在进行设备搜索
const Blu_notFindTheDev=2;//没有发现指定设备，这边没法实现，因为在不停的上报发现设备
const Blu_connected=3;//已连接
const Blu_notFindTheSev=4;//没有发现指定服务
const Blu_notFindTheCharacter=5;//没有发现合适特征值
const Blu_canSendMsg=6; //可以发送消息
const Blu_disConnect=7; //连接中断
var bluAviable = false;
var androidBLE = androidBLE || window.androidBLE
var androidBluUse={
 
  /**/
    cfg:{
     device_name:"" ,
     device_info:"", //广播特征值进行匹配
     server_info:"",
     write_id:"",
     notify_id:"",
     notify_descript_id:"",
     onBluState:null, //各状态
     onReceiveMsg:null,
   },
   blue_data:{
//     equipment_id:"",// 设备的id或者蓝牙的mac地址，写在ad消息中的
      device_id:"", //蓝牙的uuid
//     service_id:"",
//     write_id:"",
//     read_id:"",
   },
   setCfg(obj){
     this.cfg = Object.assign(this,this.cfg,obj);
   },
   /*重置数据*/
   reset(){
//     this.blue_data.equipment_id ="" ;
     this.blue_data.device_id ="" ;
//     this.blue_data.service_id ="" ;
//     this.blue_data.write_id ="" ;
//     this.blue_data.read_id="";
     this.onBluState&&this.onBluState(Blu_init);
   },
  connect(){
        
      var _this = this;
      bluAviable=false;//跟踪先前蓝牙的状态
      console.log("9999")
      if(androidBLE.openBluetooth()){
         bluAviable=true;
          _this.startSearch();

      }else{
          plus.nativeUI.toast("请先在设置中开启蓝牙")
          //alert("Ddd")
          _this.onBluState&&_this.onBluState(Blu_UnAvailable);
      }
      androidBLE.onBluetoothStateChange("androidBluUse._onBluStateChange");
    },

 
     /*蓝牙状态int,  0 未知  2 关闭中 3 开启中 4 蓝牙关闭 5 启动成功（搜索）*/
     _onBluStateChange(state){
         var _this = this
         console.log("onBluStateChange："+state)

        // alert("onBluStateChange："+state+bluAviable)
         if(!bluAviable&&state==5){
             console.log("8888")
             setTimeout(function(){
               _this.connect()

             },2000)
         }
         if(bluAviable&&state!=5){
             _this.onBluState&&_this.onBluState(Blu_UnAvailable)
         }
         bluAviable=state==5?true:false
     },

  getBlueState() {
    console.log("777");

     if(this.blue_data.device_id != ""){
         this.connectDevice();
         return;
       }

      var res= androidBLE.getBluetoothStatus()
      if(res==5){
            this.startSearch()
      }else{

      }

  },

  startSearch(){
     this.onBluState&&this.onBluState( Blu_findingDev);

     var infos={
        "eqDeviceId":this.device_info,
        "allowDuplicatesKey":false,
         "name":this.device_name,
        "type":0
     }

      androidBLE.startBluetoothDevicesDiscovery(JSON.stringify(infos))
      androidBLE.onBluetoothDeviceFound("androidBluUse._onBluDevFound");
   },

   _onBluDevFound(devInfostr){

      //  alert(JSON.stringify(devInfostr))
       
//       alert(JSON.parse(devInfostr))
       //var devices=JSON.parse(devInfostr);
       
       var device = this.filterDeviceByNameAndAd(devInfostr);

       if(device){
           this.blue_data.device_id = device.deviceId;
           this.stopSearch();
           this.connectDevice();
       }
   },
  //连接到设备
  connectDevice(){
     console.log("6666")
     var connectInfo={
         "success":"androidBluUse._onConnectSuccess",
         "fail":"androidBluUse._onConnectFail",
         "deviceId":this.blue_data.device_id
     }
     androidBLE.createBLEConnection(JSON.stringify(connectInfo))
     androidBLE.onBLEConnectionStateChange("androidBluUse._onBluConnectStateChange");
  },

  _onConnectSuccess(){
      this.onBluState && this.onBluState(Blu_connected);
       /*不用定时器调用getDeviceService()没有响应*/
      //alert("_onConnectSuccess")
      this.getDeviceService();


  },
  _onConnectFail(){
      this.onBluState && this.onBluState(Blu_disConnect);
  },


   _onBluConnectStateChange(state){
        //alert(state)
        if(state==1){
           //alert("ssss")
            this.onBluState && this.onBluState(Blu_connected);
        }else{
            this.onBluState && this.onBluState(Blu_disConnect);
        }
   },

  //搜索设备服务
   getDeviceService(){
     console.log("deviceId for services:"+this.blue_data.device_id)
     var infos={
         "success":"androidBluUse._onGetServiceSuc",
         "fail":"androidBluUse._onGetServiceFail",
         "deviceId":this.blue_data.device_id,

     }
       //alert("getDeviceService")
     androidBLE.getBLEDeviceServices(JSON.stringify(infos))

   },

   _onGetServiceSuc(){
//       var services=JSON.parse(serviceStr.services);
       this.openNotify();

   },
   _onGetServiceFail(){
       this.onBluState&&this.onBluState( Blu_notFindTheSev);
   },





   openNotify(){
       var infos={
           "success":"androidBluUse._onOpenNotifySuc",
           "fail":"androidBluUse._onOpenNotifyFail",
           "serviceId":this.server_info,
           "notifyId":this.notify_id,
            "notifyDescriptId":this.notify_descript_id,
       }

       androidBLE.notifyBLECharacteristicValueChange(JSON.stringify(infos));


   },
   _onOpenNotifySuc(){
        var _this = this;
        setTimeout(function(){
            _this.onBluState && _this.onBluState( Blu_canSendMsg);
        },1000);
        this.onNotifyChange();//接收消息
        console.log('+++++++++++_onOpenNotifySuc++++++++++++');
   },

   _onOpenNotifyFail(){
    console.log('++++++++++++_onOpenNotifyFail++++++++++++++');
   },




   //监听消息
   onNotifyChange(){
       androidBLE.onBLECharacteristicValueChange("androidBluUse._onCharacterValueChange")
   },

   _onCharacterValueChange(msg){
    //let msg = this.arrayBufferToHexString(value);
    console.log("_onCharacterValueChange:"+msg);
    alert(msg)

      let value = this.hexStringToArrayBuffer(msg)
      this.onReceiveMsg && this.onReceiveMsg(msg,value);
      console.log(msg);

  },
   //发送消息
    //发送消息
    sendMsg(msg,toArrayBuf = true) {
      // console.log(":"+this.blue_data.write_id)
     //let buf = toArrayBuf ? this.hexStringToArrayBuffer(msg) : msg;
      let msgStr="";
      if(!toArrayBuf){
        msgStr=this.arrayBufferToHexString(msg)
      }else{
        msgStr=msg
      }
      console.log("sendmsg:"+msgStr);
      let infos={
        "success":"androidBluUse._onSendSuc",
        "fail":"androidBluUse._onSendFail",
        "writeId":this.write_id,
         "value":msgStr ,
    }

     androidBLE.writeBLECharacteristicValue(JSON.stringify(infos))
  },

  _onSendSuc(res){
      console.log('write suc'+res);
  },
  _onSendFail(res){
      console.log('write error:'+res);
  },

  /*其他辅助模块*/
   //停止搜索周边设备
   stopSearch() {

     androidBLE.stopBluetoothDevicesDiscovery();
   },
    /*关闭连接和适配器，在页面退出时执行*/
   close(){

     androidBLE.closeBLEConnection()

      if(androidBLE.closeBluetooth()){

          this.onBluState&&this.onBluState(Blu_init);
      }


     /*关闭蓝牙适配器后，仍然可以收到适配器状态变化的消息，比较奇怪*/


   },



   arrayBufferToHexString(buffer) {
     let bufferType = Object.prototype.toString.call(buffer)
     if (bufferType != '[object ArrayBuffer]') {
       return
     }
     let dataView = new DataView(buffer)

     var hexStr = '';
     for (var i = 0; i < dataView.byteLength; i++) {
       var str = dataView.getUint8(i);
       //console.log(str)
       var hex = (str & 0xff).toString(16);
       hex = (hex.length === 1) ? '0' + hex : hex;
       hexStr += hex;
     }

     return hexStr.toUpperCase();
   },
   hexStringToArrayBuffer(str) {
     if (!str) {
       return new ArrayBuffer(0);
     }

     var buffer = new ArrayBuffer(str.length);
     let dataView = new DataView(buffer)

     let ind = 0;
     for (var i = 0, len = str.length; i < len; i += 2) {
       let code = parseInt(str.substr(i, 2), 16)
       dataView.setUint8(ind, code)
       ind++
     }

     return buffer;
   },
   //过滤目标设备,通过广播
   filterDeviceByAd(devices){
     if(devices==null){
         return null;
     }
     var data="";
     var device=null;
     for(var i in devices){
         device=devices[i];
         data = bluUse.arrayBufferToHexString(device.advertisData);
         if (data && data.indexOf(this.device_info) > -1) {
             var obj = { name: device.name, deviceId: device.deviceId }
             return obj
         }

     }
     return null;
   },
   filterDeviceByName(devices){
     if(devices==null||this.device_name==""){
         return null;
     }
     var data="";
     var device=null;
     for(var i in devices){
         device=devices[i];
         data = device.name;
         console.log(data)
         if (data && data.indexOf(this.device_name) > -1) {
             var obj = { name: device.name, deviceId: device.deviceId }
             return obj
         }
     }

     return null;

   },
    filterDeviceByNameAndAd(devices){
        
           if(devices==null||this.device_name==""||this.device_info==""){
               return null;
           }


           var data="";
           var device=null;
           for(var i in devices){
               
               

               device=devices[i];
               
             if (device.name && device.name.indexOf(this.device_name) > -1) {
                 console.log("find:"+JSON.stringify(device))
                 /*由于从广播消息中得到的数据有问题，所以改为从名字中来，只针对杯垫*/
                 let ads=device.name.split(" ");
                 this.device_name
                 if(ads.length>1){
                     data=ads[ads.length-1]

                 }else{
                     console.log('advertisData:'+"get ads from name error")
                     return null;
                 }


                 // data = bluUse.arrayBufferToHexString(device.advertisData);
                 console.log('advertisData:'+data);

//                     data=this.device_info
//                     console.log('advertisData1:'+data);
                 if (data && data.indexOf(this.device_info) > -1) {
                     var obj = { name: device.name, deviceId: device.deviceId }
                     return obj
                 }
             }

           }
           return null;
   },
   //过滤主服务
   filterService(services){
               // console.log("the server_info:"+this.server_info+" services len:"+services.length)‘
     let service_id = "";

     if(services==null||this.server_info==""){
         return "";
     }
     let _server_info = this.server_info.toUpperCase().split(','); // []  

     for(let i = 0;i<services.length;i++){
          console.log("server_info:"+services[i].uuid)

       if (services[i].uuid.toUpperCase().indexOf(_server_info[0]) != -1 || (_server_info[1] && services[i].uuid.toUpperCase().indexOf(_server_info[1]) != -1)) {
         service_id = services[i].uuid;
         break;
       }

       // if(services[i].uuid.toUpperCase().indexOf(this.server_info.toUpperCase()) != -1){
       //   service_id = services[i].uuid;
       //   break;
       // }
     }

     return service_id;
   },
   /*其他辅助模块*/
 
};
window.androidBluUse = androidBluUse;